config/routes.rb
Rails.application.routes.draw do
  # get 'search/people'
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  root 'home#index'
  get 'home/index'

  resources :community_surveys do
    resources :houses do
      resources :family_folders do
        resources :house_health_surveys
        get '/people/search/:id', to: 'people#search'
        resources :people do
          resources :person_health_surveys
          resources :home_visits
        end
      end
    end
  end

  # Address
  get 'addr/update_amphur/:id', to: 'addresses#update_amphur'
  get 'addr/update_tambon/:id', to: 'addresses#update_tambon'

  # Authentication
  get '/login', to: 'sessions#new'
  post '/login', to: 'sessions#create'
  delete '/logout', to: 'sessions#destroy'

  get '/goto_house', to: 'home#house'
  get '/goto_house_health_survey', to: 'home#house_health_survey'
  get '/goto_person', to: 'home#person'
  get '/goto_person_health_survey', to: 'home#person_health_survey'
  get '/goto_home_visit', to: 'home#home_visit'

  get 'communities/search', to: 'community_surveys#search_main'
  resources :diseases

  # Report
  # resources :reports
  # get '/reports', to: 'reports#community_survey'
  get '/reports/overall', to: 'reports#overall'
  get '/reports/community', to: 'reports#community_survey'
  get '/reports/admin/health_survey', to: 'reports#admin_health_survey'
  get '/reports/admin/home_visit', to: 'reports#admin_home_visit'
  get '/reports/admin/houses', to: 'reports#admin_houses'
  get '/reports/admin/people', to: 'reports#admin_people'
  get '/reports/site/health_survey', to: 'reports#site_health_survey'
  get '/reports/site/home_visit', to: 'reports#site_home_visit'
  get '/reports/site/houses', to: 'reports#site_houses'
  get '/reports/site/people', to: 'reports#site_people'

  get '/hospitals', to: 'hospitals#search'
  get '/hospitals/type/:id', to: 'hospitals#by_type'

  # Search
  # get '/search', to: 'search#search_people'
  # Test
  get '/search', to: 'search#people'
end

app/models/person.rb
class Person < ApplicationRecord
  scope :filter_by_person_id, -> (person_id) { where person_id: person_id }

  # Hooks Events
  before_create :pre_create
  before_update :update_u_date
  after_initialize :init

  belongs_to :title
  belongs_to :house
  belongs_to :family_folder
  has_many :diseases
  accepts_nested_attributes_for :diseases, allow_destroy: true, reject_if: proc { |attributes| attributes['name'].blank? }

  # Validation
  validates :person_id, allow_blank: true, allow_nil: true, uniqueness: true,
                        length: { minimum: 13, maximum: 13 }
  validates :hospcode, allow_blank: true, length: { minimum: 5, maximum: 5 }
  validates :sex, presence: true

  enum name_register: {
    have_list: 1,
    bangkok_list: 2,
    country_list: 3,
    not_have_foreign_list: 4,
    unknown: 5
  }

  enum status_person: {
    type1: 1,
    type2: 2,
    type3: 3,
    type4: 4,
    type5: 5
  }

  enum marital_state: {
    maritalstate_type1: 1,
    maritalstate_type2: 2,
    maritalstate_type3: 3,
    maritalstate_type4: 4,
    maritalstate_type5: 5,
    maritalstate_type6: 6
  }
  enum peducate: {
    educate_type1: 1,
    educate_type2: 2,
    educate_type3: 3,
    educate_type4: 4,
    educate_type5: 5,
    educate_type6: 6,
    educate_type7: 7,
    educate_type8: 8,
    educate_type9: 9
  }

  enum pcareer: {
    career_type1: 1,
    career_type2: 2,
    career_type3: 3,
    career_type4: 4,
    career_type5: 5,
    career_type6: 6,
    career_type7: 7,
    career_type8: 8,
    career_type9: 9,
    career_type10: 10,
    career_type11: 11
  }

  enum pcommustate: {
    commustate_type1: 1,
    commustate_type2: 2,
    commustate_type3: 3,
    commustate_type4: 4,
    commustate_type5: 5,
    commustate_type6: 6,
    commustate_type7: 7,
    commustate_type8: 8
  }

  enum pmaininscl: {
    maininscl_type1: 1,
    maininscl_type2: 2,
    maininscl_type3: 3,
    maininscl_type4: 4
  }

  enum ppracsick: {
    pracsick_type1: 1,
    pracsick_type2: 2,
    pracsick_type3: 3,
    pracsick_type4: 4,
    pracsick_type5: 5,
    pracsick_type6: 6,
    pracsick_type7: 7,
    pracsick_type8: 8,
    pracsick_type9: 9,
    pracsick_type10: 10
  }

  attr_accessor :age

  def short
    "#{first_name} #{last_name}"
  end

  private

  def autoid
    site = Site.hospcode hospcode
    no = site.p_no + 1
    site.update(p_no: no)
    "#{hospcode}#{no.to_s.rjust(8, '0')}"
  end

  def init
    self.birth_date = Date.today if birth_date.nil? && new_record?
    self.datesurvey = Date.today if datesurvey.nil? && new_record?
    # self.datemovin = Date.today if datemovin.nil? && new_record?
    if age.nil? && new_record?
      self.age = 0
    elsif !birth_date.nil?
      self.age = Date.today.year - birth_date.year
    end
  end

  def pre_create
    self.person_id = autoid
    update_u_date
  end

  def update_u_date
    self.u_date = updated_at
  end
end

app/controllers/people_controller.rb
class PeopleController < ApplicationController
  before_action :set_community_survey
  before_action :set_house
  before_action :set_family_folder
  before_action :set_person, only: %i[show edit update destroy search]

  # GET /people
  # GET /people.json
  def index
    @people = Person.where(family_folder: @family_folder).order(created_at: :desc).page page_param
    @people = @people.filter_by_person_id(params[:person_id]) if params[:person_id].present?
    respond_to do |format|
      format.html { render :index }
      format.json do
        people = @people.map { |f| [f.short, f.person_id] }
        label = people.empty? ? t(:no_data_label) : t(:please_select_label)
        people = people.unshift([label, '""'])
        render json: people, status: :ok
      end
    end
  end

  # GET /people/1
  # GET /people/1.json
  def show
    @titles = Title.all
  end

  # GET /people/new
  def new
    @titles = Title.all
    @person = Person.new
    @person.diseases.build
  end

  # GET /people/1/edit
  def edit
    @titles = Title.all
  end

  # POST /people
  # POST /people.json
  def create
    @person = Person.new(person_params)

    if params[:add_disease]
      # add empty ingredient associated with @recipe
      @person.diseases.build
      @titles = Title.all
      render :new
    elsif params[:remove_disease]
      # nested model that have _destroy attribute = 1 automatically deleted by rails
      @titles = Title.all
      render :new
    else
      respond_to do |format|
        if @person.save
          timestamp = Time.now
          logger.info "[FF] Person [#{@person.id}] created by #{current_user.username} at #{timestamp}"
          AuditLog.create user: current_user.username, category: 'PERSON', action: "created [#{@person.id}] at #{timestamp}"
          format.html do
            redirect_to community_survey_house_family_folder_person_path(@community_survey, @house, @family_folder, @person),
                        notice: t('person.m_created_label')
          end
          format.json { render :show, status: :created, location: @person }
        else
          @titles = Title.all
          format.html { render :new }
          format.json { render json: @person.errors, status: :unprocessable_entity }
        end
      end
    end
  end

  # PATCH/PUT /people/1
  # PATCH/PUT /people/1.json
  def update
    if params[:add_disease]
      unless params[:person][:diseases_attributes].blank?
        params[:person][:diseases_attributes].each do |attribute|
          @person.diseases.new(attribute.last.except(:_destroy).permit!) unless attribute.last.key?(:id)
        end
      end
      @person.diseases.build
      @titles = Title.all
      render :edit
    elsif params[:remove_disease]
      @titles = Title.all
      unless params[:person][:diseases_attributes].nil?
        removed_diseases = params[:person][:diseases_attributes].values.map do |att|
          att[:id] if att[:id] && att[:_destroy].to_i == 1
        end
        Disease.delete(removed_diseases)
        params[:person][:diseases_attributes].each do |attribute|
          @person.diseases.new(attribute.last.except(:_destroy).permit!) if !attribute.last.key?(:id) && attribute.last[:_destroy].to_i.zero?
        end
      end
      render :edit
    else
      respond_to do |format|
        if @person.update(person_params)
          timestamp = Time.now
          logger.info "[FF] Person [#{@person.id}] updated by #{current_user.username} at #{timestamp}"
          AuditLog.create user: current_user.username, category: 'PERSON', action: "updated [#{@person.id}] at #{timestamp}"
          format.html do
            redirect_to community_survey_house_family_folder_person_path(@community_survey, @house, @family_folder, @person),
                        notice: t('person.m_updated_label')
          end
          format.json { render :show, status: :ok, location: @person }
        else
          @titles = Title.all
          format.html { render :edit }
          format.json { render json: @person.errors, status: :unprocessable_entity }
        end
      end
    end
  end

  # DELETE /people/1
  # DELETE /people/1.json
  def destroy
    timestamp = Time.now
    @person.destroy
    logger.info "[FF] Person [#{@person.id}] destroyed by #{current_user.username} at #{timestamp}"
    AuditLog.create user: current_user.username, category: 'PERSON', action: "destroyed [#{@person.id}] at #{timestamp}"
    respond_to do |format|
      format.html do
        redirect_to community_survey_house_family_folder_people_path(@community_survey, @house,
                                                                     @family_folder),
                    notice: t('person.m_deleted_label')
      end
      format.json { head :no_content }
    end
  end

  def search
    @people = Person.where(family_folder: @family_folder, person_id: @person.id).order(created_at: :desc).page page_param
    render :index
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_person
    @person = Person.find(params[:id])
  end

  def set_family_folder
    @family_folder = FamilyFolder.find(params[:family_folder_id])
  end

  def set_house
    @house = House.find(params[:house_id])
  end

  def set_community_survey
    @community_survey = CommunitySurvey.find(params[:community_survey_id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def person_params
    datesurvey_param = params.fetch(:person, {}).fetch(:datesurvey)
    birthdate_param = params.fetch(:person, {}).fetch(:birth_date)

    diseases_params = params.fetch(:person, {}).fetch(:diseases_attributes, {})
    diseases_params.each do |k, v|
      diseases_params[k] = diseases_params[k].merge(sick_at: convert_buddhist_year_to_gregorian_year(v.fetch(:sick_at)))
    end

    params.fetch(:person, {}).merge(hospcode: current_user.hospcode,
                                    house: @house,
                                    family_folder: @family_folder,
                                    diseases_attributes: diseases_params,
                                    datesurvey: convert_buddhist_year_to_gregorian_year(datesurvey_param),
                                    birth_date: convert_buddhist_year_to_gregorian_year(birthdate_param)).permit!
  end
end

app/helpers/people_helper.rb
module PeopleHelper
  def total_people(value)
    return t(:not_found_label) if value.nil?
    value.size
  end
end

app/views/people/edit.html.erb
<%= render 'form', community_survey: @community_survey, house: @house, 
                   family_folder: @family_folder, person: @person %>
<% content_for :menu_content_title do %>
  <div><%= t 'person.edit_label' %></div>
<% end %>

app/views/people/index.html.erb
<div class="container">
  <% unless notice.nil? %>
    <div id="notice">
      <div class="ui message icon">
        <i class="close icon"></i>
        <i class="info circle icon"></i>
        <div class="content">
          <%= notice %>
        </div>
      </div>
    </div>
  <% end %>
  <% unless @people.empty? %>
    <table class="ui table unstackable --responsive">
      <thead>
        <tr>
          <th class="center aligned"><%= t 'no_label' %></td>
          <th class="center aligned"><%= t 'person.person_id_label' %></td>
          <th class="center aligned"><%= t 'person.first_name_label' %> - <%= t 'person.last_name_label' %></td>
          <th class="center aligned"><%= t 'person_health_survey.datesurvey_label' %></th>
          <th class="center aligned"><%= t 'person_health_survey.u_date' %></th>
          <th colspan="3" class="center aligned"><%= t :actions_label %></th>
        </tr>
      </thead>
      <tbody>
        <% @people.each_with_index do |person, index| %>
          <tr>
            <td class="center aligned" data-label="<%= t 'no_label' %>"><%= no(@people) + index %></td>
            <td data-label="<%= t 'person.person_id_label' %>"><%= person.person_id %></td>
            <td data-label="<%= t 'person.person_id_label' %>"><%= person.first_name %> <%= person.last_name %></td>
            <td class="center aligned" data-label="<%= t 'person_health_survey.datesurvey_label' %>"><%= date_format(person.datesurvey) %></td>
            <td class="center aligned" data-label="<%= t 'person_health_survey.u_date' %>"><%= date_time_format(person.u_date) %></td>
            <td class="action --center">
              <%= link_to t('person_health_survey.title_label'), community_survey_house_family_folder_person_person_health_surveys_path(@community_survey, @house, @family_folder, person) %>
              <%= link_to t('home_visit.title_label'), community_survey_house_family_folder_person_home_visits_path(@community_survey, @house, @family_folder, person) %>
              <%= link_to [@community_survey, @house, @family_folder, person], data: { tooltip: t('info_label'), position: "bottom left" }, class: "ui button --circle --submit" do %>
                <i class="info icon"></i>
              <% end %>
              <%= link_to edit_community_survey_house_family_folder_person_path(@community_survey, @house, @family_folder, person),
                data: { tooltip: t('edit_label'), position: "bottom left" },
                class: "ui button --circle --submit" do %>
                <i class="ico-edit"></i>
              <% end %>
              <%= link_to  community_survey_house_family_folder_person_path(@community_survey, @house, @family_folder, person), method: :delete, 
                data: { confirm: t(:confirm_delete_label), tooltip: t('destroy_label'), position: "bottom right" }, class: "ui button --circle --submit" do %>
                <i class="ico-bin"></i>
              <% end %>
            </td>
          </tr>
        <% end %>
      </tbody>
    </table>
    
    <div class="pagination">
      <%= paginate @people %>
    </div>
  <% else %>
    <div class="container__no-content">
      <div>
        <div class="container__no-content --icon">
          <i class="file outline icon"></i>
        </div>
        <div class="container__no-content --text"><%= t('person.title_label_not_found') %></div>
        <div class="container__no-content --button">
          <%= link_to new_community_survey_house_family_folder_person_path(@community_survey, @house, @family_folder), 
                      class: "ui button --icon-only" do %>
            <%= t 'person.add_label' %>
          <% end %>
        </div>
      </div>
    </div>
  <% end %>
</div>

<% content_for :menu_content_title do %>
  <div class="menuFilter-contentLeft__button">
    <button id="toggle_breadcrumb" class="ui button active --toggle">
      <i id="toggle_breadcrumb_icon" class="ellipsis vertical icon"></i>
    </button>
  </div>
  <div class="ui breadcrumb">
    <% if params[:person_id].present? %>
      <%= link_to community_surveys_path(vid: params[:community_survey_id], value: params[:value]), class: 'section' do %>
        <div class="breadcrumb__label"><%= t('community_survey.title_label') %></div>
        <div class="breadcrumb__content">(<%= @community_survey.vname %>)</div>
      <% end %>
      <i class="right angle icon divider"></i>
      <%= link_to t('house.title_label'),
        community_survey_houses_path(params[:community_survey_id], hid: params[:house_id], value: params[:value]),
        class: 'section'
      %>
      <i class="right angle icon divider"></i>
      <%= link_to t('family_folder.title_label'), 
        community_survey_house_family_folders_path(@community_survey, @house, family_folder_id: params[:family_folder_id], value: params[:value]),
        class: 'section'
      %>
      <i class="right angle icon divider"></i>
      <div class="active section"><%= t 'person.title_label' %></div>

      <% content_for :clear_search do %>
        <%= link_to t("clear_search_label"), community_survey_house_family_folder_people_path(
          @community_survey,
          @house,
          @family_folder), class: "ui button" %>
      <% end %>
    <% else %>
      <%= link_to community_surveys_path, class: 'section' do %>
        <div class="breadcrumb__label"><%= t('community_survey.title_label') %></div>
        <div class="breadcrumb__content">(<%= @community_survey.vname %>)</div>
      <% end %>
      <i class="right angle icon divider"></i>
      <%= link_to t('house.title_label'), community_survey_houses_path(@community_survey), class: 'section' %>
      <i class="right angle icon divider"></i>
      <%= link_to t('family_folder.title_label'), 
        community_survey_house_family_folders_path(@community_survey, @house), class: 'section' %>
      <i class="right angle icon divider"></i>
      <div class="active section"><%= t 'person.title_label' %></div>
    <% end %>
  </div>
<% end %>
<% content_for :menu_content_link do %>
  <%= link_to new_community_survey_house_family_folder_person_path(@community_survey, @house, @family_folder), class: "ui button --icon-only", data: { tooltip: t('person.add_label'), position: "left center" } do %>
    <div class="icon-group">
      <i class="ico-add"></i>
      <i class="ico-person-alt"></i>
    </div>
  <% end %>
<% end %>

app/views/people/new.html.erb
<%= render 'form', community_survey: @community_survey, house: @house, family_folder: @family_folder, person: @person %>
<% content_for :menu_content_title do %>
  <div><%= t 'person.add_label' %></div>
<% end %>

app/views/people/show.html.erb
<% unless notice.nil? %>
  <div id="notice">
    <div class="ui message icon">
      <i class="close icon"></i>
      <i class="info circle icon"></i>
      <div class="content">
        <%= notice %>
      </div>
    </div>
  </div>
<% end %>

<%= render 'people/info',community_survey: @community_survey, house: @house, family_folder: @family_folder, person: @person %>
<% content_for :menu_content_title do %>
  <div><%= t 'person.title_label' %></div>
<% end %>